#include <math.h>
#include <stdio.h>
#include <sprlib.h>
#include <graphics.h>

double evalclass(double** coefmatrix,double *coefvector,double coef,double* medidas,int nmedidas)
{
double cuad_term,lin_term;
double* tmpresult;

tmpresult=vector(1,nmedidas);

matvecmult (coefmatrix, nmedidas, nmedidas, medidas,tmpresult);
cuad_term=vecinmult(medidas,nmedidas,tmpresult);

lin_term=vecinmult(medidas,nmedidas,coefvector);
free_vector(tmpresult,1,nmedidas);

return(cuad_term+lin_term+coef);
}




extern void exit();

main()
{
	int gdriver = DETECT, gmode, errorcode;


	SAMPLE *medidas_ptr;
	DATASET *dset;
	int clase0=0,clase1=1;
	double **coefmatrix,*coefvector,coef;
	double* medidas;
	int nmedidas;
	int i,j,color;
	int clase;
	int classcolor[3];

    
	sprinit(INIT_EXIT);
	initgraph(&gdriver, &gmode, "");
	errorcode = graphresult();
	if (errorcode != grOk) {
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		printf("Press any key to halt:");
		getch();
		exit(1);
	}
	dset = load_dataset("fisher.txt");
	nmedidas=dset->NumInputs;
	coefmatrix=matrix(1,nmedidas,1,nmedidas);
	coefvector=vector(1,nmedidas);
	medidas=vector(1,nmedidas);


	fisherq_dataset(dset,clase0,clase1,1.0,coefmatrix,coefvector,&coef);
	classcolor[0]=BLACK;classcolor[1]=WHITE;classcolor[2]=YELLOW;


	for (i=0;i<480;i++)
		for(j=0;j<480;j++)
		{
			medidas[1]=40*((float)i)/480+40;
			medidas[2]=40*((float)j)/480+15;
			color=(evalclass(coefmatrix,coefvector,coef,medidas,nmedidas)>0? BLUE:RED);
			putpixel(i, 480-j, color);
		}

	medidas_ptr=dset->FirstSample;
	while(medidas_ptr)
	{
					i=(int)(480*(medidas_ptr->Input[1]-40)/40);
					j=(int)(480*(medidas_ptr->Input[2] -15)/40);
					j=480-j;
					clase=medidas_ptr->Output.Label;
					if(clase==clase0||clase==clase1)
					{
						color=classcolor[medidas_ptr->Output.Label];
						setcolor(color);
						setfillstyle(SOLID_FILL, color);
						fillellipse(i,j,3,3);
					}
					medidas_ptr = medidas_ptr->Next;
	}


	free_matrix(coefmatrix,1,nmedidas,1,nmedidas);
	free_vector(coefvector,1,nmedidas);
	free_vector(medidas,1,nmedidas);

    getch();
	sprexit(EXIT_SILENT);

	return 0;
}
